diff --git a/src/regexp/ast_to_re.cc b/src/regexp/ast_to_re.cc
index 7bc4ce2e1..e9b74c8f0 100644
--- a/src/regexp/ast_to_re.cc
+++ b/src/regexp/ast_to_re.cc
@@ -433,11 +433,11 @@ LOCAL_NODISCARD(Ret ast_to_re(RESpec& spec,
         case AstKind::CAP:
             if (!opts->tags_posix_syntax) { // ordinary group, replace with subexpr on stack
                 x.ast = ast->cap;
-            } else { // POSIX capturing group
+            } else { // capturing group
                 if (x.succ == 0) { // 1st visit: push successor
                     ++x.succ;
                     x.re1 = capture_tags(spec, x, false, &ast, pncap);
-                    stack.emplace_back(ast,  x.height, x.in_iter);
+                    stack.emplace_back(ast, x.height, x.in_iter);
                 } else { // 2nd visit: return
                     re = insert_between_tags(spec, x.re1, re);
                     stack.pop_back();
@@ -446,7 +446,18 @@ LOCAL_NODISCARD(Ret ast_to_re(RESpec& spec,
             break;
 
         case AstKind::REF:
-            x.ast = ast->ref;
+            if (!opts->tags_posix_semantics) { // ordinary group, replace with subexpr on stack
+                x.ast = ast->ref;
+            } else { // non-capturing group
+                if (x.succ == 0) { // 1st visit: push successor
+                    ++x.succ;
+                    x.re1 = structural_tags(spec, x, ast->ref, pncap);
+                    stack.emplace_back(ast->ref, x.height, x.in_iter);
+                } else { // 2nd visit: return
+                    re = insert_between_tags(spec, x.re1, re);
+                    stack.pop_back();
+                }
+            }
             break;
 
         case AstKind::ALT:
diff --git a/test/posix_captures/non_capturing_explicit_2.c b/test/posix_captures/non_capturing_explicit_2.c
index 6843ff5f9..bc3479302 100644
--- a/test/posix_captures/non_capturing_explicit_2.c
+++ b/test/posix_captures/non_capturing_explicit_2.c
@@ -242,7 +242,7 @@
 			yyt1 = YYCURSOR;
 			goto yy39;
 		default:
-			yyt2 = NULL;
+			yyt2 = yyt3 = NULL;
 			yyt1 = YYCURSOR;
 			goto yy38;
 	}
@@ -250,21 +250,32 @@
 	yynmatch = 3;
 	yypmatch[0] = yyt1;
 	yypmatch[3] = yyt2;
-	yypmatch[5] = yyt2;
+	yypmatch[5] = yyt3;
 	yypmatch[1] = YYCURSOR;
 	yypmatch[2] = yyt2;
 	if (yyt2 != NULL) yypmatch[2] -= 2;
-	yypmatch[4] = yyt2;
-	if (yyt2 != NULL) yypmatch[4] -= 2;
+	yypmatch[4] = yyt3;
+	if (yyt3 != NULL) yypmatch[4] -= 2;
 	{}
 yy39:
+	++YYCURSOR;
+	if (YYLIMIT <= YYCURSOR) YYFILL(1);
+	yych = *YYCURSOR;
+	switch (yych) {
+		case 'a': goto yy40;
+		default:
+			yyt2 = yyt3 = NULL;
+			goto yy38;
+	}
+yy40:
 	++YYCURSOR;
 	if (YYLIMIT <= YYCURSOR) YYFILL(1);
 	yych = *YYCURSOR;
 	switch (yych) {
 		case 'a': goto yy39;
 		default:
-			yyt2 = NULL;
+			yyt3 = NULL;
+			yyt2 = YYCURSOR;
 			goto yy38;
 	}
 }
diff --git a/test/posix_captures/non_capturing_explicit_4.c b/test/posix_captures/non_capturing_explicit_4.c
index 76147af47..d1ea20beb 100644
--- a/test/posix_captures/non_capturing_explicit_4.c
+++ b/test/posix_captures/non_capturing_explicit_4.c
@@ -242,7 +242,7 @@
 			yyt1 = YYCURSOR;
 			goto yy39;
 		default:
-			yyt2 = NULL;
+			yyt2 = yyt3 = NULL;
 			yyt1 = YYCURSOR;
 			goto yy38;
 	}
@@ -250,21 +250,32 @@
 	yynmatch = 3;
 	yypmatch[0] = yyt1;
 	yypmatch[3] = yyt2;
-	yypmatch[5] = yyt2;
+	yypmatch[5] = yyt3;
 	yypmatch[1] = YYCURSOR;
 	yypmatch[2] = yyt2;
 	if (yyt2 != NULL) yypmatch[2] -= 2;
-	yypmatch[4] = yyt2;
-	if (yyt2 != NULL) yypmatch[4] -= 2;
+	yypmatch[4] = yyt3;
+	if (yyt3 != NULL) yypmatch[4] -= 2;
 	{}
 yy39:
+	++YYCURSOR;
+	if (YYLIMIT <= YYCURSOR) YYFILL(1);
+	yych = *YYCURSOR;
+	switch (yych) {
+		case 'a': goto yy40;
+		default:
+			yyt2 = yyt3 = NULL;
+			goto yy38;
+	}
+yy40:
 	++YYCURSOR;
 	if (YYLIMIT <= YYCURSOR) YYFILL(1);
 	yych = *YYCURSOR;
 	switch (yych) {
 		case 'a': goto yy39;
 		default:
-			yyt2 = NULL;
+			yyt3 = NULL;
+			yyt2 = YYCURSOR;
 			goto yy38;
 	}
 }
diff --git a/test/posix_captures/non_capturing_implicit_1.c b/test/posix_captures/non_capturing_implicit_1.c
index 7bd5cf3fd..37a22a51f 100644
--- a/test/posix_captures/non_capturing_implicit_1.c
+++ b/test/posix_captures/non_capturing_implicit_1.c
@@ -242,7 +242,7 @@
 			yyt1 = YYCURSOR;
 			goto yy39;
 		default:
-			yyt2 = NULL;
+			yyt2 = yyt3 = NULL;
 			yyt1 = YYCURSOR;
 			goto yy38;
 	}
@@ -250,21 +250,32 @@
 	yynmatch = 3;
 	yypmatch[0] = yyt1;
 	yypmatch[3] = yyt2;
-	yypmatch[5] = yyt2;
+	yypmatch[5] = yyt3;
 	yypmatch[1] = YYCURSOR;
 	yypmatch[2] = yyt2;
 	if (yyt2 != NULL) yypmatch[2] -= 2;
-	yypmatch[4] = yyt2;
-	if (yyt2 != NULL) yypmatch[4] -= 2;
+	yypmatch[4] = yyt3;
+	if (yyt3 != NULL) yypmatch[4] -= 2;
 	{}
 yy39:
+	++YYCURSOR;
+	if (YYLIMIT <= YYCURSOR) YYFILL(1);
+	yych = *YYCURSOR;
+	switch (yych) {
+		case 'a': goto yy40;
+		default:
+			yyt2 = yyt3 = NULL;
+			goto yy38;
+	}
+yy40:
 	++YYCURSOR;
 	if (YYLIMIT <= YYCURSOR) YYFILL(1);
 	yych = *YYCURSOR;
 	switch (yych) {
 		case 'a': goto yy39;
 		default:
-			yyt2 = NULL;
+			yyt3 = NULL;
+			yyt2 = YYCURSOR;
 			goto yy38;
 	}
 }
